//__________________________________________________________________________
// P REISS   2009		Malt.cpp

#include "string.h"
#include "stdlib.h"             // utilitaire d' allocation
#include "GraTypes.h"

double Dynar[1];                // adresse de reference
static char  *Alo[5];           // adresses d' allocation
static silla Nof[5], Loc;
static int   Nos[5] = { 0, 0, 0, 0, 0 };
                                // longueurs allouees, decalages
 
// Malt alloue une zone memoire de Lod mots de 4 ou 8 octets si necessaire

extern "C" silla Malt ( int *Lod, int *Rang, silla *Col )
  // longueur demandee, numero d'alloc, offset de 2eme colonne
  // *Rang = 0   => inutilise
  // *Rang = 1   => 'display list' graphique juste pour les types
  // *Rang = 2   => double x[ny], y[ny] dans Vibour
  // *Rang = 3   => float ax[ny ou 3][2] de Viaxor
  {
  char     *Alu;
  double   *Vieux, *Neuf;
  unsigned int Type;
  silla    Decal;
  int      Deja, Numero, Lot;
 
  Numero = *Rang;
  Deja   = Nos[Numero];

  if ( *Lod > Deja )
    {
    Nos[Numero] += *Lod + 32;
    Lot = Nos[Numero];
    Loc = Lot;				// seulement si *Rang = 2
    if ( Numero == 2 )   Lot *= 2;
    Type = 2;
    if ( Numero > 1 )   Type = 3;	// int ou double

    Alu = (char*) malloc ( ( Lot + 1 ) << Type );
					// allocation en octets
    Decal = ( ( (ulla) Alu - (ulla) Dynar ) >> Type ) + 1;
    if ( Deja )
      {
      Deja <<= 2;
      if ( Numero == 2 )
        {
        Deja <<= 1;
        Vieux = Dynar + Nof[Numero];
        Neuf  = Dynar + Decal;
        memcpy ( Neuf, Vieux, Deja );	// rearrangement
        Lot   = Deja;
        memcpy ( Neuf + Loc, Vieux + (Deja >> 3), Lot );
        }
      else if ( Numero == 1 )
        memcpy ( ( (int *) Dynar ) + Decal,
		 ( (int *) Dynar ) + Nof[Numero], Deja );
      free ( Alo[Numero] );		// liberation
      }

    Alo[Numero] = Alu;
    Nof[Numero] = Decal;
    Loc += Decal;			// seulement si *Rang = 2
    }

  *Col = Loc;				// seulement si *Rang = 2
  return ( Nof[Numero] );
  }
//__________________________________________________________________________
