// Praxes.cpp
// P REISS   2009
// OPEN, CLOSE, READ et WRITE dans un fichier texte

#include "stdio.h"        // pour fclose, fgets, fputs...
#include "string.h"
FILE *pentree;
static char Fic[256+1];
static char *Flags[] = {"r","w"};

extern "C" int Praxes ( char *Car, int *Cnt, int *Ich )
// _ chaine lue ou ecrite, nom du fichier a ouvrir ou fermer
// _ nombre de caracteres lus, nul si fin fichier;
//   nombre de caracteres de Car
// _ choix: 1(OPEN R), 2(OPEN W), 3(READ)
//          4(WRITE), 5(CLOSE)
  {
  int  Jdx, Kdx, PourTabu, Len, Accu;
  char Cur, *Cor, *Cer;

  switch ( *Ich )
    {
    case 1 :					// OPEN
    case 2 :
      if ( strcmp ( Car, "STDIN" ) == 0 )
        pentree = stdin;
      else
        {
        Cer = Car;
        Kdx = 0;
        while ( *Cer != ' '   &&   Kdx < *Cnt )   Fic[Kdx++] = *Cer++;
        Fic[Kdx] = '\0';
        pentree = fopen ( Fic, Flags[*Ich - 1] );
        if ( !pentree )   return 1;		// erreur
        }
      break;
    case 3 :
      {						// READ
      *Cnt = 256+1;
      Cor  = fgets ( Fic, *Cnt, pentree );

      // printf("Cnt %d\n",*Cnt); printf("Cor %s\n",Cor);

      Cer  = Car;
      *Cnt = 0;
      if ( Cor != NULL )
        {
        Len = (int) strlen ( Cor );
        if ( Len == 1 )
          {   // presence de '\n' conservee
          *Cer++ = ' ';
          *Cer++ = '\n';
          (*Cnt)++;
          }
        else
          {
          for ( Accu=0, Jdx=0; Jdx<Len; Jdx++ )
            {
            Cur = *Cor;
            if ( Cur != '\t' )
              {
              (*Cnt)++;
              Accu++;
              if ( Accu > 256-2 ) break;
              *Cer++ = Cur;
              }
            else
              {
              PourTabu = 8 - ( *Cnt % 8 );
              (*Cnt) += PourTabu;
              Accu   += PourTabu;
              if ( Accu > 256-2 ) break;
              for ( Kdx=1; Kdx<=PourTabu; Kdx++ )
                *Cer++ = ' ';
              }
            Cor++;
            }
          }
        *Cer = '\0';
        }
      break;
      }
    case 4 :
      {						// WRITE
      fputs ( Car, pentree );
      break;
      }
    case 5 :
      {						// CLOSE
      fclose ( pentree );
      break;
      }
    }
  return 0;
  }
