//_________________________________________________________________________
// P REISS   Vigies      bouclage sous handler d' evenement
// structures externes declarees ici

#include "math.h"
#include "string.h"
#include "Pro.h"
#include "Traces.h"
extern   double Dynar[1];
struct   Sot    Local;
//_________________________________________________________________________
// Vilimit necessite par probleme d' optimiseur sur boucle Pdx
// Avec une structure Sot au lieu de l' instance de classe Set
// (Microsoft abuse des acces memoire si on travaille directement dans Set,
//  alors que Sot est elegamment accede avec xmm4, xmm5, xmm6, xmm7)

extern "C" void Vilimit ( silla Jux, silla Juy, int AffCnt )
  {					// equivalence (C, _Ax)
  double (*C)[2][2] = (double (*)[2][2]) &Local._Ax;
  double Fo, Side;
  silla  Jdx, Kdx;
  int    Idx, Pdx;

  Local._Ax = Dynar[Jux];
  Local._Bx = Local._Ax;
  Local._Ay = Dynar[Juy];
  Local._By = Local._Ay;

  for ( Jdx=Jux+1, Kdx=Juy+1, Pdx=1; Pdx<AffCnt; Pdx++ )
    {
    Fo        = Dynar[Jdx++];
    Local._Ax = Local._Ax < Fo   ?   Local._Ax   :   Fo;
    Local._Bx = Local._Bx > Fo   ?   Local._Bx   :   Fo;
    Fo        = Dynar[Kdx++];
    Local._Ay = Local._Ay < Fo   ?   Local._Ay   :   Fo;
    Local._By = Local._By > Fo   ?   Local._By   :   Fo;
    }

  // un peu de gras sur le cadre: 5% de tous les cotes

  Fo = 0.1;
  for ( Idx=0; Idx<2; Idx++ )
    {
    Side          = fabs ( (*C)[Idx][1] - (*C)[Idx][0] ) * Fo;
    (*C)[Idx][0] -= Side;
    (*C)[Idx][1] += Side;
    Fo            = 0.05;
    }
  }
//_________________________________________________________________________
void Set::Vigies ()
  {
  // _Ku = 3   retrace pur
  // si Ku == 1, (PremAff, AffCnt) agrandissent le cadre d' ecretage
  //   dans un rapport 3, pour le dragging
  //   si [A,B] est le segment ecrete (en X ou en Y),
  //   on prend en compte [2*A-B, 2*B-A]
  //   ----|------------|------------|------------|-----------> axe X
  //     2*A-B          A            B          2*B-A
  //   1er trace:
  //                   PA         PA+AC-1
  //   Ku == 1:
  //      PA                                   PA+AC-1

  double (*C)[2][2] = (double (*)[2][2]) &_Xa;
  silla  Jux, Juy;			// equivalence (C, _Xa)
  int    Idx, Edx, Jy[2];
  static int Un = 1;
  //_______________________________________________________________________
  // 1 _ changement de visu: rebouclage

  if ( _Ku == 1 )
    {
    // X en Dynar[_Iou[0]], Y en Dynar[_Iou[1]]
    // recherche dichotomique dans tableau trie flottant
    // place _Pu dans X[] trie

    for ( Idx=0; Idx<2; Idx++ )
      Jy[Idx] = Search
        ( Dynar + _Iou[0], 
          _Pu[Idx][0] + _Pu[Idx][0] - _Pu[1-Idx][0], _TotCnt );

    _PremAff = Jy[0]>0 ? Jy[0] : 0;
    _AffCnt  = ( _TotCnt<Jy[1]+2 ? _TotCnt : Jy[1]+2 ) - _PremAff;
    }
  //_______________________________________________________________________
  // 2 _ cadrage: rectangle d' encombrement

  Jux = _Iou[0];
  Juy = _Iou[1];

  if ( _Ku < 3 )
    {
    if ( _Ku == 2 )
      {					// 1er trace
      Vilimit ( Jux, Juy, _AffCnt );
      memcpy  ( this, &Local._Ax, 4*sizeof(double) );
      }
    else
      {                                 // recadrage
      for ( Idx=0; Idx<2; Idx++ )	// pas de gras
        for ( Edx=0; Edx<2; Edx++ )
          (*C)[Idx][Edx] = _Pu[Edx][Idx];
      }
    //_____________________________________________________________________
    // 3 _ preparation d' interaction

    for ( Idx=0; Idx<2; Idx++ )
      {
      _VueTaille[Idx] = _Aje[Idx][1] - _Aje[Idx][0];
      for ( Edx=0; Edx<2; Edx++ )
        // window = (xmin=_Aje[0][0], xmax=_Aje[0][1])
        //          (ymin=_Aje[1][0], ymax=_Aje[1][1])
        _Wi[Idx][Edx] = _Aje[Idx][Edx];
      }
    }
  //_______________________________________________________________________
  // 4 _ preparation du trace

  Gpest  ( &Un );			// vide primitives tracees

  // calcul des parametres de cadrage automatique
  Vicair ();

  // courbes + axes + graduations
  Viaxor ( Dynar+Jux, Dynar+Juy, (float*) (Dynar+_Iou[2]) );

  // fin de display list fixe pour gl
  Vifics ();

  // restitution du point: coordonnees user -> _Aje raster
  Visdor ();
  }
//_________________________________________________________________________
