//_________________________________________________________________________
// P REISS     Visdar
// calendrier valide pour dates = [01 janvier 1900, 31 decembre 9999]
//                       Visdas = [ (dimanche)   1,          2958463]

#include <stdio.h>
#include <math.h>
#include "Pro.h"
//_________________________________________________________________________
// ici, Mois(Mars)=1;   Year s' etend sur [01/03, 28ou29/02]
// floor(-0.5) = -1.

static int Vingt ( int Day, int Mois, int Year )// joue role de code
  {                                             // commun a 2 entrys
  int Resu = Day + ( Year - 1900 ) * 365 + floor ( Year * .25 )
             + floor ( Year * .25e-2 ) - floor ( Year * 1.e-2 )
             + floor ( 30.6 * Mois - .19 ) - (1+475+4-19+30-60);
  return Resu;
  }
//_________________________________________________________________________
// donne numero Visdas du jour Jour ( "dd/mm/yyyy" )
// jour / mois / millesime

extern "C" int Visdas ( char *Jour )		// Jour[11]
  {
  int  Day, Mois, Year;

  sscanf ( Jour, "%2d/%2d/%4d", &Day, &Mois, &Year );
						// read interne
  Mois -= 2;
  if ( Mois < 1 )
    {
    Mois += 12;
    Year --;
    }
  return Vingt ( Day, Mois, Year );
  }
//_________________________________________________________________________
// reciproque de Visdas
// donne jour Visdar ( dd/mm/yyyy ) par son numero *Jour
// Sor: char[11] en sortie, '\0' compris

extern "C" void Visdar ( int *Jour, char *Sor )
  {
  int Day, Mois, Year, Ajour;

  Day = *Jour;

  // calcul de l' annee Year approchee par defaut
  // ( 1 annee = 365.242216 jours )

  Year  = floor ( ( Day - 60.87001 ) / 365.2425 ) + 1900;
  Ajour = Vingt ( 1, 1, Year );
  if ( Day - Ajour >= 365 )
    {
    Mois = Vingt ( 1, 1, Year + 1 );
    if ( Day >= Mois )
      {
      Year ++;
      Ajour = Mois;
      }
    }
  // vrai pour (Day - Ajour) sur [0, 365 ou 366[

  Mois  = floor ( ( Day - Ajour + 31.19 ) / 30.6 );
  Day  += 1 - Vingt ( 1, Mois, Year );
  Mois += 2;
  if ( Mois > 12 )
    {
    Mois -= 12;
    Year ++;
    }
  sprintf ( Sor, "%2d/%2d/%4d", Day, Mois, Year );
  }						// write interne
//_________________________________________________________________________
//*** programme de test de Visdar+Visdas:
// #include "stdio.h"
// #include "Pro.h"
// int main ()
//   {
//   char Date[11];
//   int  Jour, Inv;
//   for ( Jour=1; Jour<2958464; Jour++ )
//     {
//     Visdar ( &Jour, Date );
//     if ( Jour != (Inv = Visdas ( Date )) )   break;
//     }
//   printf ( "Jour=%d Date=%s Inv=%d\n", Jour-1, Date, Inv );
//   return 0;
//   }
//_________________________________________________________________________
